#include once "FileIterator.bi"

Constructor FileIteratorW(ByRef ListingDir As WString)
	
	hFind = INVALID_HANDLE_VALUE
	pListingDir = @ListingDir
	resFindNext = TRUE
	
End Constructor

Destructor FileIteratorW()
	
	If hFind <> INVALID_HANDLE_VALUE Then
		FindClose(hFind)
	End If
	
End Destructor

Operator FileIteratorW.For()
	
	hFind = FindFirstFileW( _
		pListingDir, _
		@FindData _
	)
	
End Operator

Operator FileIteratorW.Step()
	
	resFindNext = FindNextFileW( _
		hFind, _
		@FindData _
	)
	
End Operator

Operator FileIteratorW.Next(ByRef endCond As FileIteratorW) As Integer
	
	If hFind = INVALID_HANDLE_VALUE Then
		Return 0
	End If
	
	If resFindNext = 0 Then
		Return 0
	End If
	
	Return 1
	
End Operator
