#include once "windows.bi"
#include once "crt.bi"

Type FileIteratorW
	Declare Constructor(ByRef ListingDir As WString)
	Declare Destructor()
	Declare Operator For()
	Declare Operator Step()
	Declare Operator Next(ByRef endCond As FileIteratorW) As Integer
	
	FindData As WIN32_FIND_DATAW
	hFind As HANDLE
	pListingDir As WString Ptr
	resFindNext As BOOL
End Type

Const NewLine = !"\r\n"
Const FormatString = !"%s\r\n"

	
	For fff As FileIteratorW = WStr("*") To WStr("")
		wprintf(@WStr(FormatString), @fff.FindData.cFileName)
	Next
	
Constructor FileIteratorW(ByRef ListingDir As WString)
	
	hFind = INVALID_HANDLE_VALUE
	pListingDir = @ListingDir
	resFindNext = TRUE
	
End Constructor

Destructor FileIteratorW()
	
	If hFind <> INVALID_HANDLE_VALUE Then
		FindClose(hFind)
	End If
	
End Destructor

Operator FileIteratorW.For()
	
	hFind = FindFirstFileW( _
		pListingDir, _
		@FindData _
	)
	
End Operator

Operator FileIteratorW.Step()
	
	resFindNext = FindNextFileW( _
		hFind, _
		@FindData _
	)
	
End Operator

Operator FileIteratorW.Next(ByRef endCond As FileIteratorW) As Integer
	
	If hFind = INVALID_HANDLE_VALUE Then
		Return 0
	End If
	
	If resFindNext = 0 Then
		Return 0
	End If
	
	Return 1
	
End Operator
