rem Compile Release
set FBC_DIR=C:\Program Files (x86)\FreeBASIC-1.10.0-winlibs-gcc-9.3.0
"%FBC_DIR%\fbc64.exe" -gen gcc -d UNICODE -d WITHOUT_RUNTIME -w error -maxerr 1 -i src -i "%FBC_DIR%\inc" -r -s console -O 0 ShowDirectories.bas
"%FBC_DIR%\fbc64.exe" -gen gcc -d UNICODE -d WITHOUT_RUNTIME -w error -maxerr 1 -i src -i "%FBC_DIR%\inc" -r -s console -O 0 FileIterator.bas

rem Fix emitted code
cscript.exe //nologo fix-emitted-code.vbs /release ShowDirectories.c
cscript.exe //nologo fix-emitted-code.vbs /release FileIterator.c

rem Compile to object files
"C:\Program Files\LLVM\bin\clang.exe" -m64 -march=native -pipe -Wall -Werror -Wextra -pedantic -Wno-unused-label -Wno-unused-function -Wno-unused-parameter -Wno-unused-variable -Wno-dollar-in-identifier-extension -Wno-language-extension-token -Wno-parentheses-equality  -fno-math-errno -fno-exceptions -fno-unwind-tables -fno-asynchronous-unwind-tables -O3 -fno-ident -fdata-sections -ffunction-sections -flto   -c -o ShowDirectories.o ShowDirectories.c
"C:\Program Files\LLVM\bin\clang.exe" -m64 -march=native -pipe -Wall -Werror -Wextra -pedantic -Wno-unused-label -Wno-unused-function -Wno-unused-parameter -Wno-unused-variable -Wno-dollar-in-identifier-extension -Wno-language-extension-token -Wno-parentheses-equality  -fno-math-errno -fno-exceptions -fno-unwind-tables -fno-asynchronous-unwind-tables -O3 -fno-ident -fdata-sections -ffunction-sections -flto   -c -o FileIterator.o FileIterator.c

rem Link object files
"C:\Program Files\LLVM\bin\ld.lld.exe" -e EntryPoint -m i386pep -subsystem console --no-seh --nxcompat -L . -L "%FBC_DIR%\lib\win64" -s --gc-sections  ShowDirectories.o FileIterator.o --start-group -ladvapi32 -lcrypt32 -lkernel32 -lmsvcrt -lole32 -loleaut32 -lmswsock -lws2_32 -lshell32 -lshlwapi -lgdi32 -luser32 -lcomctl32 --end-group  -o ShowDirectories.exe

rem Only for display disassembly code
rem "C:\Program Files\mingw64\bin\objcopy.exe" -O binary -j .text -j .text "file3.exe" "file3.bin"
rem "C:\Program Files\mingw64\bin\objdump.exe" -D -b binary -m i386:x86-64 "file3.bin"

"C:\Program Files (x86)\FreeBASIC-1.10.0-winlibs-gcc-9.3.0\fbc64.exe" iter.bas